package algo.tp.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class TableCell extends JPanel {
	private int price, amount, pseudoPrice;

	private boolean belongToBasis;

	private Font amountFont = new Font("Helvetica", Font.BOLD, 16);

	private Font priceFont = new Font("Helvetica", Font.PLAIN, 13);

	private JLabel[] labels = new JLabel[9];

	private LineBorder border = new LineBorder(Color.BLACK, 1);

	private Color myColor = new Color(0, 68, 0);

	private String empty = " ";

	private String content = "";

	public TableCell(String arg) {
		super(new GridLayout(3, 3));
		this.content = arg;
		this.setBorder(border);
		this.setBackground(Color.WHITE);
		for (int i = 0; i < 9; i++) {
			labels[i] = new JLabel();
			this.add(labels[i]);
		}
		initAsString();

	}

	public TableCell(int price) {
		super(new GridLayout(3, 3));
		this.setBorder(border);
		this.setBackground(Color.WHITE);
		this.price = price;
		for (int i = 0; i < 9; i++) {
			labels[i] = new JLabel();
			this.add(labels[i]);
		}
		init();

	}

	private void initAsString() {
		labels[4].setFont(amountFont);
		labels[4].setForeground(Color.RED);
		labels[4].setText(content);
	}

	private void init() {
		labels[0].setFont(priceFont);
		labels[0].setForeground(Color.BLUE);
		labels[0].setText(empty + price);
	}

	public void reinit(int amount, int pseudoPrice, boolean belongToBasis, boolean startCycle) {
		this.amount = amount;
		this.pseudoPrice = pseudoPrice;
		this.belongToBasis = belongToBasis;
		labels[0].setFont(priceFont);
		labels[0].setForeground(Color.BLUE);
		labels[0].setText(empty + price);
		labels[8].setFont(priceFont);
		labels[8].setForeground(myColor);
		labels[8].setText(empty + (price - pseudoPrice));
		if (belongToBasis) {
			labels[4].setFont(amountFont);
			labels[4].setForeground(Color.RED);
			labels[4].setText(empty + amount);	
		} else {
			labels[4].setText("");
		}
		if (startCycle) {
			labels[4].setFont(amountFont);
			labels[4].setForeground(Color.RED);
			labels[4].setText("X");
		}
	}

	public int getAmount() {
		return amount;
	}

	public int getPrice() {
		return price;
	}

	public int getPseudoPrice() {
		return pseudoPrice;
	}

	public boolean isBasisCell() {
		return belongToBasis;
	}
}
