package algo.tp.model;


public class StoreAmounts {
    private int count;
    private int[] amounts;
    private int[] potentials;
    private boolean[] defs;

    public StoreAmounts(int[] array) {
        this.count = array.length;
        amounts = new int[count];
        defs = new boolean[count];
        potentials = new int[count];
        for(int i=0; i<count; i++) {
            this.amounts[i] = array[i];
            defs[i] = false;
        }
    }

    public int getCount() {
        return count;
    }

    public boolean isDefined(int number) {
        return defs[number -1];
    }

    public boolean allDefined() {
        boolean b = true;
        for(int i = 0; i<count; i++) {
            if(!defs[i]) {
                b = false;
            }
        }
        return b;
    }

    public void reset() {
        for(int i = 0; i<count; i++) {
            defs[i] = false;
        }
    }

    public int getAmount(int number) {
        return amounts[number -1];
    }

    public int getPotential(int number) {
        return potentials[number-1];
    }

    public void setPotential(int number, int potential) {
        potentials[number-1] = potential;
        defs[number-1] = true;
    }


}
